include masm32rt.inc
include psapi.inc
includelib psapi.lib
include Shlwapi.inc
includelib Shlwapi.lib

include PWL.inc

PPCHAR typedef ptr PCHAR
GetProcesses proto ppProcessIds: ptr PDWORD,pppszName:ptr PPCHAR
FreeProcessNames proto ppszNames:ptr PCHAR,nProcesses:DWORD
GetProcessName proto dwProcessID:DWORD
ProcessWatcher proto hEvent:HANDLE

.code
entry:

CreateProcessWatcher proc
LOCAL dwPWThreadID:DWORD
	mov edx,rv(CreateEvent,0,1,0,0)
	push edx
	invoke CloseHandle,rv(CreateThread,0,0,ProcessWatcher,edx,0,ADDR dwPWThreadID)
	mov edx,DWORD ptr [esp]
	invoke WaitForSingleObject,edx,INFINITE
	pop edx
	invoke CloseHandle,edx
	mov eax,dwPWThreadID
	ret
	
CreateProcessWatcher endp

ProcessWatcher proc hEvent:HANDLE
LOCAL hTimer:HANDLE
LOCAL msg:MSG
LOCAL pProcessIds[2]:PDWORD
LOCAL nProcesses[2]:DWORD	
LOCAL ppszNames[2]:ptr PCHAR
LOCAL dwInterval:DWORD
LOCAL ppw:ptr PROCESS_WATCHER
LOCAL npw:DWORD
LOCAL DueTime:LARGE_INTEGER
	
	
	invoke IsGUIThread,1
	invoke SetEvent,hEvent
	mov npw,0
	mov ppw,0
	mov dwInterval,250
	mov nProcesses[4],rv(GetProcesses,ADDR pProcessIds[4],ADDR ppszNames[4])

	mov hTimer,rv(CreateWaitableTimer,0,0,0)

	mov DWORD ptr DueTime[0],-100
	mov DWORD ptr DueTime[4],-1
	invoke SetWaitableTimer,hTimer,ADDR DueTime,dwInterval,0,0,0

	.while 1
		invoke MsgWaitForMultipleObjects,1,ADDR hTimer,0,INFINITE,QS_POSTMESSAGE
		.if eax == WAIT_OBJECT_0 + 1
			.while 1
				.break .if !rv(PeekMessage,ADDR msg,0,0,0,PM_REMOVE)
				.if msg.message == WM_QUIT
					invoke CloseHandle,hTimer
					free pProcessIds[4]
					invoke FreeProcessNames,ppszNames[4],nProcesses[4]
					mov ebx,ppw
					.while 1
						mov edi,[ebx].PROCESS_WATCHER.pNext
						free ebx
						.break .if !edi
						mov ebx,edi
					.endw
					invoke ExitThread,0
				.elseif msg.message == PWM_ADD_WND
					.if npw
						mov ebx,ppw
						.while [ebx].PROCESS_WATCHER.pNext
							mov ebx,[ebx].PROCESS_WATCHER.pNext
						.endw
						mov edi,alloc(SIZEOF PROCESS_WATCHER)
						mov [ebx].PROCESS_WATCHER.pNext,edi
						mov esi,msg.wParam
						mov ecx,SIZEOF PROCESS_WATCHER
						cld
						rep movsb
						inc npw
						mov eax,[ebx].PROCESS_WATCHER.pNext
						mov [eax].PROCESS_WATCHER.pNext,0
					.else
						mov edi,alloc(SIZEOF PROCESS_WATCHER)
						mov ebx,edi
						mov esi,msg.wParam
						mov ecx,SIZEOF PROCESS_WATCHER
						cld
						rep movsb
						mov [ebx].PROCESS_WATCHER.pNext,0
						mov npw,1
						mov ppw,ebx
					.endif
					free msg.wParam
				.elseif msg.message == PWM_REMOVE_WND
					.if npw
						mov ebx,ppw
						xor edi,edi
						.while 1
							mov esi,msg.wParam
							.if [ebx].PROCESS_WATCHER.hWnd == esi
								.if edi
									m2m [edi].PROCESS_WATCHER.pNext,[ebx].PROCESS_WATCHER.pNext
								.else
									m2m ppw,[ebx].PROCESS_WATCHER.pNext
								.endif
								free ebx
								dec npw
								.break
							.endif
							.break .if ![ebx].PROCESS_WATCHER.pNext
							mov edi,ebx
							mov ebx,[ebx].PROCESS_WATCHER.pNext
						.endw
					.endif
				.elseif msg.message == PWM_SET_INTERVAL
					m2m dwInterval,msg.wParam
					invoke SetWaitableTimer,hTimer,ADDR DueTime,dwInterval,0,0,0
				.endif
			.endw
		.elseif eax == WAIT_OBJECT_0
			;/* get current process list */
			mov nProcesses,rv(GetProcesses,ADDR pProcessIds,ADDR ppszNames)

			;/* search for new processes */
			mov edi,pProcessIds
			xor ebx,ebx
			.while ebx < nProcesses
				mov eax,DWORD ptr [edi+ebx*4]
				mov esi,pProcessIds[4]
				xor ecx,ecx
				.while ecx < nProcesses[4]
					.if eax == DWORD ptr [esi+ecx*4]
						xor eax,eax
						.break
					.endif
					lea ecx,[ecx+1]
				.endw
				.if eax
					;/* new process */
					pushad
					.if npw
						mov esi,ppw
						.while 1
							mov eax,ppszNames
							lea ecx,[len(PCHAR ptr [eax+ebx*4])+1]
							mov edx,alloc(ecx)
							push edx
							mov eax,ppszNames
							invoke szCopy,rv(PathFindFileName,PCHAR ptr [eax+ebx*4]),DWORD ptr [esp]
							pop edx
							invoke PostMessage,[esi].PROCESS_WATCHER.hWnd,[esi].PROCESS_WATCHER.uiMsg_start,DWORD ptr [edi+ebx*4],edx
							.break .if ![esi].PROCESS_WATCHER.pNext
							mov esi,[esi].PROCESS_WATCHER.pNext
						.endw
					.endif
					popad
				.endif
				lea ebx,[ebx+1]
			.endw
			
			;/* search for missing/closed processes */
			mov edi,pProcessIds[4]
			xor ebx,ebx
			.while ebx < nProcesses[4]
				mov eax,DWORD ptr [edi+ebx*4]
				mov esi,pProcessIds
				xor ecx,ecx
				.while ecx < nProcesses
					.if eax == DWORD ptr [esi+ecx*4]
						xor eax,eax
						.break
					.endif
					lea ecx,[ecx+1]
				.endw
				.if eax
					;/* missing process */
					pushad
					.if npw
						mov esi,ppw
						.while 1
							mov eax,ppszNames[4]
							lea ecx,[len(PCHAR ptr [eax+ebx*4])+1]
							mov edx,alloc(ecx)
							push edx
							mov eax,ppszNames[4]
							invoke szCopy,rv(PathFindFileName,PCHAR ptr [eax+ebx*4]),DWORD ptr [esp]
							pop edx
							invoke PostMessage,[esi].PROCESS_WATCHER.hWnd,[esi].PROCESS_WATCHER.uiMsg_stop,DWORD ptr [edi+ebx*4],edx
							.break .if ![esi].PROCESS_WATCHER.pNext
							mov esi,[esi].PROCESS_WATCHER.pNext
						.endw
					.endif
					popad
				.endif
				lea ebx,[ebx+1]
			.endw
			
			free pProcessIds[4]
			invoke FreeProcessNames,ppszNames[4],nProcesses[4]
			m2m pProcessIds[4],pProcessIds[0]
			m2m nProcesses[4],nProcesses[0]
			m2m ppszNames[4],ppszNames[0]
		.else
			.break
		.endif
	.endw
	
	ret
	
ProcessWatcher endp


GetProcesses proc uses esi edi ebx ppProcessIds: ptr PDWORD,pppszName:ptr PPCHAR
LOCAL cb:DWORD	
	
	mov esi,1024*(SIZEOF DWORD)
	mov edi,alloc(esi)
	.while 1
		.break .if rv(EnumProcesses,edi,esi,ADDR cb)
		lea esi,[esi*2]
		free edi
		mov edi,alloc(esi)
	.endw
	
	mov eax,ppProcessIds
	mov PDWORD ptr [eax],edi
	
	mov esi,cb
	shr esi,2
	mov cb,esi
	
	mov esi,alloc(ADDR [esi*4])
	xor ebx,ebx
	.while ebx < cb
		mov [esi+ebx*4],rv(GetProcessName,DWORD ptr [edi+ebx*4])
		lea ebx,[ebx+1]
	.endw
	mov eax,pppszName
	mov PCHAR ptr [eax],esi
	
	mov eax,cb
	ret
	
GetProcesses endp

FreeProcessNames proc uses esi ebx ppszNames:ptr PCHAR,nProcesses:DWORD

	mov esi,ppszNames
	xor ebx,ebx
	.while ebx < nProcesses
		free PCHAR ptr [esi+ebx*4]
		lea ebx,[ebx+1]
	.endw
	free esi
	ret
	
FreeProcessNames endp

GetProcessName proc uses edi ebx dwProcessID:DWORD
	
	mov edi,alloc(1024)
	.if rv(OpenProcess,PROCESS_QUERY_INFORMATION,0,dwProcessID)
		mov ebx,eax	
		invoke GetProcessImageFileName,ebx,edi,1024
		push eax
		invoke CloseHandle,ebx
		pop eax
@@:		test eax,eax
		jz @F
	.else
@@:		fn szCopy,"| NA |",edi
	.endif
	mov eax,edi
	
	ret
	
GetProcessName endp

end entry